import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';


export default ({
    block,
    displayName
} = {}) => {

    return React.createClass({

        displayName,

        mixins: [PureRenderMixin],

        propTypes: {
            disabled: PropTypes.bool,
            highlighted: PropTypes.bool,
            text: PropTypes.string,
            to: PropTypes.string
        },

        getDefaultProps() {
            return {
                disabled: false,
                highlighted: false,
                text: '',
                to: ''
            };
        },

        onClick(evt) {
            if (this.props.disabled) {
                evt.preventDefault();
            }
        },

        render() {
            const { disabled, highlighted, text, to } = this.props;
            return (
                <a
                    className={ block('option', { disabled, highlighted }) }
                    data-load="static"
                    href={ to }
                    onClick={ this.onClick }
                    title={ text }>
                    { text }
                </a>
            );
        }

    });

};
