import React, { PropTypes } from 'react';
import { connect } from 'react-redux';
import invariant from 'invariant';

import actionName from '../../utils/actionName';
import getComponentState from '../../utils/getComponentState';

import textareaChange from './redux-actions/textareaChange';


const changeType = actionName('CHANGE');

export {
    changeType
};

export default ({
    Component
} = {}) => {

    invariant(Component !== undefined, 'Missing Textarea component.');

    const Container = React.createClass({

        displayName: `${Component.displayName}Container`,

        propTypes: {
            path: PropTypes.string.isRequired,
            root: PropTypes.string.isRequired,
            // ---
            actionTypePrefix: PropTypes.string
        },

        render() {
            return (
                <Component { ...this.props } />
            );
        }

    });

    const mapStateToProps = (state, props) => {
        const { value } = getComponentState(state, props);
        return {
            value
        };
    };

    const mapDispatchToProps = (dispatch, props) => {
        const { path, root } = props;
        const actionTypePrefix = props.actionTypePrefix || 'TEXTAREA';

        return {
            onChange: (value) => dispatch(textareaChange({ path, root, type: changeType(actionTypePrefix), value }))
        };
    };

    return connect(mapStateToProps, mapDispatchToProps)(Container);

};
