import Immutable from 'seamless-immutable';
import { applyMiddleware, combineReducers, createStore } from 'redux';
import thunk from 'redux-thunk';

import {
    componentsReducer,
    messageReducer
} from '../reducers';


export default (defaultComponentState = {}) => {
    const root = combineReducers({
        actions: (state = Immutable([]), action = {}) => {
            if (action.type === '@@redux/INIT') {
                return state;
            }

            return [...state, action];
        },
        components: componentsReducer({ defaultState: defaultComponentState }),
        messages: messageReducer
    });

    return createStore(
        (state, action) => {
            return Immutable(root(state, action));
        },
        Immutable({}),
        applyMiddleware(
            thunk
        )
    );
};
